%global dlrn_nvr ec2-api-8.0.0.dev1-0.20180802202420.0243b82
%global dlrn 1
%define upstream_version 8.0.0.dev1
%global pypi_name ec2-api

%if 0%{?fedora}
# FIXME: python3 clients are not packaged yet
%global with_python3 0
%{!?python3_shortver: %global python3_shortver %(%{__python3} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}
%endif

%{!?upstream_version: %global upstream_version %{version}%{?milestone}}

%global common_desc \
Support of EC2 API for OpenStack.

Name:           openstack-%{pypi_name}
Version: 8.0.0
Release: 0.20190202002420.0243b82%{?dist}
Summary:        OpenStack Ec2api Service

License:        ASL 2.0
URL:            https://launchpad.net/ec2-api
Source0: ec2-api-8.0.0.dev1-0.20180802202420.0243b82-0243b82bf03d7f54206a96a3ff650faa6a29211d.tar.gz
Source1:        openstack-ec2-api.service
Source2:        openstack-ec2-api-metadata.service
Source3:        openstack-ec2-api-s3.service
Source4:        openstack-ec2-api-manage.service
Source5:        ec2api.conf.sample
Source6:        policy.json

# patches_ignore=DROP-IN-RPM
# patches_base=0243b82
Patch0002: 0002-Update-UPPER_CONSTRAINTS_FILE-for-stable-rocky.patch
Patch0003: 0003-import-zuul-job-settings-from-project-config.patch
Patch0004: 0004-Added-EC2-API-Import-Image-support-via-RegisterImage.patch
Patch0005: 0005-up-version.patch
Patch0006: 0006-Remove-install-guide-jobs.patch
Patch0007: 0007-Remove-tripleo-newton-and-ocata-jobs-rocky-branch.patch

BuildArch:      noarch

BuildRequires:  git
BuildRequires:  python2-devel
BuildRequires:  python2-setuptools
BuildRequires:  python2-pbr >= 2.0.0
BuildRequires:  systemd
BuildRequires:  openstack-macros

Requires: python2-ec2-api = %{version}-%{release}

%description
%{common_desc}

%package -n     python2-%{pypi_name}
Summary:        Support of EC2 API for OpenStack
%{?python_provide:%python_provide python2-%{pypi_name}}

Requires: python-anyjson >= 0.3.3
Requires: python2-babel >= 2.3.4
Requires: python2-botocore >= 1.5.1
Requires: python2-eventlet >= 0.18.2
Requires: python2-greenlet >= 0.4.10
Requires: python-httplib2 >= 0.9.1
Requires: python2-iso8601 >= 0.1.9
Requires: python2-jsonschema >= 2.0.0
Requires: python2-keystoneauth1 >= 3.4.0
Requires: python-lxml >= 3.2.1
Requires: python2-oslo-cache >= 1.26.0
Requires: python2-oslo-config >= 2:5.2.0
Requires: python2-oslo-concurrency >= 3.25.0
Requires: python2-oslo-context >= 2.19.2
Requires: python2-oslo-db >= 4.27.0
Requires: python2-oslo-log >= 3.36.0
Requires: python2-oslo-serialization >= 2.18.0
Requires: python2-oslo-service >= 1.24.0
Requires: python2-oslo-utils >= 3.33.0
Requires: python-paste
Requires: python-paste-deploy >= 1.5.0
Requires: python2-pbr >= 2.0.0
Requires: python2-cinderclient >= 3.3.0
Requires: python2-glanceclient >= 1:2.8.0
Requires: python2-keystoneclient >= 1:3.8.0
Requires: python2-neutronclient >= 6.7.0
Requires: python2-novaclient >= 1:9.1.0
Requires: python2-openstackclient >= 3.12.0
Requires: python2-routes >= 2.3.1
Requires: python2-six >= 1.10.0
Requires: python2-sqlalchemy >= 1.0.10
Requires: python-migrate >= 0.11.0
Requires: python-webob >= 1.7.1
Requires: python2-cryptography >= 1.7.2

%description -n python2-%{pypi_name}
%{common_desc}

# Python3 package
%if 0%{?with_python3}
%package -n     python3-%{pypi_name}
Summary:        Support of EC2 API for OpenStack
%{?python_provide:%python_provide python3-%{pypi_name}}

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-pbr >= 2.0.0
BuildRequires:  python3-tools

Requires: python3-anyjson >= 0.3.3
Requires: python3-babel >= 1.3
Requires: python3-boto >= 2.32.1
Requires: python3-botocore >= 1.0.0
Requires: python3-eventlet >= 0.17.4
Requires: python3-greenlet >= 0.3.2
Requires: python3-httplib2 >= 0.7.5
Requires: python3-iso8601 >= 0.1.9
Requires: python3-jsonschema >= 2.0.0
Requires: python3-lxml >= 2.3
Requires: python3-oslo-cache >= 1.5.0
Requires: python3-oslo-config >= 2:5.2.0
Requires: python3-oslo-concurrency >= 3.25.0
Requires: python3-oslo-context >= 2.14.0
Requires: python3-oslo-db >= 4.1.0
Requires: python3-oslo-log >= 3.36.0
Requires: python3-oslo-messaging >= 4.0.0
Requires: python3-oslo-serialization >= 1.10.0
Requires: python3-oslo-service >= 1.0.0
Requires: python3-oslo-utils >= 3.33.0
Requires: python3-paramiko >= 1.13.0
Requires: python3-paste
Requires: python3-paste-deploy >= 1.5.0
Requires: python3-pbr >= 2.2.0
Requires: python3-pyasn1
Requires: python3-pyasn1-modules
Requires: python3-cinderclient >= 3.1.0
Requires: python3-glanceclient >= 1:2.8.0
Requires: python3-keystoneclient >= 1:1.6.0
Requires: python3-neutronclient >= 6.7.0
Requires: python3-novaclient >= 1:9.1.0
Requires: python3-openstackclient >= 3.3.0
Requires: python3-routes >= 2.3.1
Requires: python3-six >= 1.10.0
Requires: python3-sqlalchemy >= 1.0.10
Requires: python3-migrate >= 0.11.0
Requires: python3-stevedore >= 1.3.0
Requires: python3-webob >= 1.7.1
Requires: python3-cryptography >= 1.6

%description -n python3-%{pypi_name}
%{common_desc}
%endif

# Documentation package
%package -n python-%{pypi_name}-doc
Summary:        Documentation for OpenStack EC2 API

BuildRequires:  python2-sphinx
BuildRequires:  python2-openstackdocstheme

%description -n python-%{pypi_name}-doc
%{common_desc}

Documentation for OpenStack EC2 API

%package -n python-%{pypi_name}-tests
Summary:    Tests for OpenStack EC2 API

Requires:   python2-%{pypi_name} = %{version}-%{release}

%description -n python-%{pypi_name}-tests
Unit tests for OpenStack EC2 API

%prep
%autosetup -n %{pypi_name}-%{upstream_version} -S git
# Remove bundled egg-info
rm -rf %{pypi_name}.egg-info

# Copy our own conf file
cp %{SOURCE5} etc/ec2api/ec2api.conf.sample

%if 0%{?with_python3}
rm -rf %{py3dir}
cp -a . %{py3dir}
2to3 --write --nobackups %{py3dir}
%endif

%build
%{__python2} setup.py build

%if 0%{?with_python3}
pushd %{py3dir}
LANG=en_US.UTF-8 %{__python3} setup.py build
popd
%endif

# generate html docs
%{__python2} setup.py build_sphinx -b html
# remove the sphinx-build leftovers
rm -rf doc/build/html/.{doctrees,buildinfo}

%install
%{__python2} setup.py install --skip-build --root %{buildroot}

%if 0%{?with_python3}
pushd %{py3dir}
LANG=en_US.UTF-8 %{__python3} setup.py install --skip-build --root %{buildroot}
mv %{buildroot}%{_bindir}/%{pypi_name} %{buildroot}%{_bindir}/python3-%{pypi_name}
popd
%endif

# rename binaries, make compat symlinks
pushd %{buildroot}%{_bindir}
%if 0%{?with_python3}
for i in %{pypi_name}-{3,%{?python3_shortver}}; do
    ln -s  python3-%{pypi_name} $i
done
%endif
popd

# Create log dir
mkdir -p %{buildroot}/var/log/ec2api/

# Install data file
install -p -D -m 640 etc/ec2api/api-paste.ini %{buildroot}%{_sysconfdir}/ec2api/api-paste.ini
install -p -D -m 640 %{SOURCE5} %{buildroot}%{_sysconfdir}/ec2api/ec2api.conf
install -p -D -m 640 %{SOURCE6} %{buildroot}%{_sysconfdir}/ec2api/policy.json

# Install services
install -p -D -m 644 %{SOURCE1} %{buildroot}%{_unitdir}/openstack-ec2-api.service
install -p -D -m 644 %{SOURCE2} %{buildroot}%{_unitdir}/openstack-ec2-api-metadata.service
install -p -D -m 644 %{SOURCE3} %{buildroot}%{_unitdir}/openstack-ec2-api-s3.service
install -p -D -m 644 %{SOURCE4} %{buildroot}%{_unitdir}/openstack-ec2-api-manage.service

# Install log file
install -d -m 755 %{buildroot}%{_localstatedir}/log/ec2api

# Create butckets dir
mkdir -p %{buildroot}%{python2_sitelib}/buckets


%pre
# Using dynamic UID and GID for ec2api
getent group ec2api >/dev/null || groupadd -r ec2api
getent passwd ec2api >/dev/null || \
useradd -r -g ec2api -d %{_sharedstatedir}/ec2api -s /sbin/nologin \
-c "OpenStack EC2 API Daemons" ec2api
exit 0


%files -n python2-%{pypi_name}
%license LICENSE
%doc README.rst
%{python2_sitelib}/ec2api
%exclude %{python2_sitelib}/ec2api/tests
%{python2_sitelib}/ec2_api-*-py?.?.egg-info

%files
%{_bindir}/%{pypi_name}*
%dir %attr(0750, root, ec2api) %{_sysconfdir}/ec2api
%attr(0644, root, ec2api) %{_sysconfdir}/ec2api/api-paste.ini
%attr(0644, root, ec2api) %{_sysconfdir}/ec2api/ec2api.conf
%attr(0644, root, ec2api) %{_sysconfdir}/ec2api/policy.json
%{_unitdir}/openstack-ec2-api.service
%{_unitdir}/openstack-ec2-api-metadata.service
%{_unitdir}/openstack-ec2-api-s3.service
%{_unitdir}/openstack-ec2-api-manage.service
%dir %attr(0750, ec2api, ec2api) %{_localstatedir}/log/ec2api

# Files for python3
%if 0%{?with_python3}
%files -n python3-%{pypi_name}
%doc README.rst
%license LICENSE
%{_bindir}/python3-%{pypi_name}
%{_bindir}/%{pypi_name}*
%{python3_sitelib}/ec2api*
%{python3_sitelib}/ec2_api*
%endif


%files -n python-%{pypi_name}-doc
%doc doc/build/html

%files -n python-%{pypi_name}-tests
%license LICENSE
%{python2_sitelib}/ec2api/tests

%changelog
* Wed Feb 20 2019 Thierry Vignaud <tvignaud@redhat.com> 8.0.0-0.20190202002420.0243b82
- Remove tripleo newton and ocata jobs (rocky branch)
- Remove install-guide-jobs
- up version
- Merge "Added EC2 API Import Image support (via RegisterImage EC2 API call)" into stable/rocky
- Added EC2 API Import Image support (via RegisterImage EC2 API call)
- import zuul job settings from project-config
- Update UPPER_CONSTRAINTS_FILE for stable/rocky
- Update .gitreview for stable/rocky

